module pipeline3(
    clk     ,
    rst_n   ,
    din_vld ,
    a       ,
    b       ,
    c       ,
    d       ,
    mul_vld ,
    mul         
    );

    //
    parameter      WIDTH_IN  =        4 ;
    parameter      WIDTH_OUT =        16;

    //źŶ
    input                   clk    ;
    input                   rst_n  ;
    input                   din_vld;
    input[WIDTH_IN-1:0]     a      ;
    input[WIDTH_IN-1:0]     b      ;
    input[WIDTH_IN-1:0]     c      ;
    input[WIDTH_IN-1:0]     d      ;

    //źŶ
    output[WIDTH_OUT-1:0]   mul    ;
    output                  mul_vld;

    //źreg
    reg[WIDTH_OUT-1:0]      mul    ;
    reg                     mul_vld;

    /*********www.mdy-edu.com ƽ עͿʼ****************
    mul
    **********www.mdy-edu.com ƽ עͽ****************/
    //mul0
    reg[2*WIDTH_IN-1:0] mul0;
    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            mul0 <= 0;
        end
        else if(din_vld)begin
            mul0 <= a * b;
        end
    end

    //mul1
    reg[2*WIDTH_IN-1:0] mul1;
    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            mul1 <= 0;
        end
        else if(din_vld_ff0)begin
            mul1 <= mul0 * c_ff0;
        end
    end

    //mul
    always@(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            mul <= 0;
        end
        else if(din_vld_ff1)begin
            mul <= mul1 * d_ff1;
        end
    end

    /*********www.mdy-edu.com ƽ עͿʼ****************
    mul_vld
    **********www.mdy-edu.com ƽ עͽ****************/
    //mul_vld
    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            mul_vld <= 0;
        end
        else begin
            mul_vld <= din_vld_ff1;
        end
    end

    //din_vld_ff0/ff1
    reg din_vld_ff0;
    reg din_vld_ff1;
    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            din_vld_ff0 <= 0;
            din_vld_ff1 <= 0;
        end
        else begin
            din_vld_ff0 <= din_vld;
            din_vld_ff1 <= din_vld_ff0;
        end
    end

    /*********www.mdy-edu.com ƽ עͿʼ****************
    c/d
     **********www.mdy-edu.com ƽ עͽ****************/   
    //c_ff0
    reg[WIDTH_IN-1:0]     c_ff0      ;
    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            c_ff0 <= 0;
        end
        else begin
            c_ff0 <= c;
        end
    end

    //d_ff1
    reg[WIDTH_IN-1:0]     d_ff0      ;
    reg[WIDTH_IN-1:0]     d_ff1      ;
    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            d_ff0 <= 0;
            d_ff1 <= 0;
        end
        else begin
            d_ff0 <= d;
            d_ff1 <= d_ff0;
        end
    end




    endmodule

